 package com.sweep15.GameElements;
 
 import java.io.Serializable;

import org.anddev.andengine.opengl.texture.region.TextureRegion;
 
/**
 * Classe que implementa una carta del joc
 * 
 * @author Sergi Collado Figueras : PFC - Xarxes de computadors 2011-2012
 *
 */
 public class Card
   implements Serializable, Comparable<Object>, Cloneable
 {
	 /* Propietats */
	 
	 private static final long serialVersionUID = 1L;
	 
	 protected Rank rank; //Valor
	 protected Suit suit; //Pal
	 protected int cardNumber; //Id
	 
	 protected boolean reversed = false; //Si est del revs
 
	 protected TextureRegion image = null; //Textura de la cara de la carta
	 protected TextureRegion imageReverse = null; //Textura del revers de la carta
	 
	 protected SpriteCard sprite = null; //SpriteCard de la carta, controla selecci, moviments, etc...
 
	 /* Constructor */
	 
	 public Card(Rank pRank, Suit pSuit, int pId) {
		 this.rank = pRank;
		 this.suit = pSuit;
		 this.cardNumber = pId;		 
	 }   
 
	 /* Getters i Setters */
	 
	 public SpriteCard getSprite() {
		 return this.sprite;
	 }
   
	 public Rank getRank() {
		 return this.rank;
	 }
 
	 public Suit getSuit() {
		 return this.suit;
	 }
 	 
	 public int getNumber() {
		 return this.cardNumber;
	 }   
 
	 public boolean isReversed() {
		 return this.reversed;
	 }
 
	 public void setReversed(boolean reversed) {
		 this.reversed = reversed;
	 }
 
	 public void setImageReverse(TextureRegion image) {
		 if (this.imageReverse == null) this.imageReverse = image; 
	 }
 
	 public void setImage(TextureRegion image) {
		 if (this.image == null) this.image = image;
	 }
 
	 public TextureRegion getImage() {
		 if (this.isReversed()) return this.imageReverse;
		 return this.image;
	 }
 
	 /* Altres funcions tils */
	 
	 public String toString() {
		 return this.rank.toString() + "-" + this.suit.toString();
	 }
 
	 public boolean equals(Object o) {
		 boolean equal = false;
		 try {
			 Card c = (Card)o;
			 if (getNumber() == c.getNumber()) equal = true; 
		 } catch (Exception e) {
		 }
		 return equal;
	 }
 
	 public int compareTo(Object obj) {
		 Card c = (Card)obj;
		 if (this.cardNumber < c.getNumber()) return -1;
 
		 if (this.cardNumber == c.getNumber()) return 0;
		 return 1;
	 }
 
	 public Card copyCard() {
		 Card c = null;
		 try {
			 c = (Card)clone(); 
		 } catch (CloneNotSupportedException e) {
		 }
		 return c;
	 }	    
 }
