 package com.sweep15.GameElements;

import org.anddev.andengine.audio.sound.Sound;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;

import android.content.Context;
 
/**
 * Classe que implementa tot el joc de cartes necessari per jugar a l'escombra
 * 
 * @author Sergi Collado Figueras : PFC - Xarxes de computadors 2011-2012
 *
 */
 public class EscobaPackage
   implements CardPackage
 {
	 /* Propietats */
	 private String NAME = "PACKAGE_ESCOBA_40";
 
	 private String EXT = ".png";
 
	 private final Suit OROS = new Suit("Oros", 1);
	 private final Suit COPAS = new Suit("Copas", 2);
	 private final Suit ESPADAS = new Suit("Espadas", 3);
	 private final Suit BASTOS = new Suit("Bastos", 4);
 
	 private final Suit[] allSuits = { this.OROS, this.COPAS, this.ESPADAS, this.BASTOS };
 
	 private final Rank AS = new Rank("As", 1);
	 private final Rank DOS = new Rank("Dos", 2);
	 private final Rank TRES = new Rank("Tres", 3);
	 private final Rank CUATRO = new Rank("Cuatro", 4);
	 private final Rank CINCO = new Rank("Cinco", 5);
	 private final Rank SEIS = new Rank("Seis", 6);
	 private final Rank SIETE = new Rank("Siete", 7);
	 private final Rank SOTA = new Rank("Sota", 8);
	 private final Rank CABALLO = new Rank("Caballo", 9);
	 private final Rank REY = new Rank("Rey", 10);
 
	 private final Rank[] allRanks = { this.AS, this.DOS, this.TRES, this.CUATRO, this.CINCO, this.SEIS, this.SIETE, this.SOTA, this.CABALLO, this.REY };
 
	 private final Card AS_OROS = new Card(this.AS, this.OROS, 1);
	 private final Card DOS_OROS = new Card(this.DOS, this.OROS, 2);
	 private final Card TRES_OROS = new Card(this.TRES, this.OROS, 3);
	 private final Card CUATRO_OROS = new Card(this.CUATRO, this.OROS, 4);
	 private final Card CINCO_OROS = new Card(this.CINCO, this.OROS, 5);
	 private final Card SEIS_OROS = new Card(this.SEIS, this.OROS, 6);
	 private final Card SIETE_OROS = new Card(this.SIETE, this.OROS, 7);
	 private final Card SOTA_OROS = new Card(this.SOTA, this.OROS, 8);
	 private final Card CABALLO_OROS = new Card(this.CABALLO, this.OROS, 9);
	 private final Card REY_OROS = new Card(this.REY, this.OROS, 10);
	 private final Card AS_COPAS = new Card(this.AS, this.COPAS, 11);
	 private final Card DOS_COPAS = new Card(this.DOS, this.COPAS, 12);
	 private final Card TRES_COPAS = new Card(this.TRES, this.COPAS, 13);
	 private final Card CUATRO_COPAS = new Card(this.CUATRO, this.COPAS, 14);
	 private final Card CINCO_COPAS = new Card(this.CINCO, this.COPAS, 15);
	 private final Card SEIS_COPAS = new Card(this.SEIS, this.COPAS, 16);
	 private final Card SIETE_COPAS = new Card(this.SIETE, this.COPAS, 17);
	 private final Card SOTA_COPAS = new Card(this.SOTA, this.COPAS, 18);
	 private final Card CABALLO_COPAS = new Card(this.CABALLO, this.COPAS, 19);
	 private final Card REY_COPAS = new Card(this.REY, this.COPAS, 20);
	 private final Card AS_ESPADAS = new Card(this.AS, this.ESPADAS, 21);
	 private final Card DOS_ESPADAS = new Card(this.DOS, this.ESPADAS, 22);
	 private final Card TRES_ESPADAS = new Card(this.TRES, this.ESPADAS, 23);
	 private final Card CUATRO_ESPADAS = new Card(this.CUATRO, this.ESPADAS, 24);
	 private final Card CINCO_ESPADAS = new Card(this.CINCO, this.ESPADAS, 25);
	 private final Card SEIS_ESPADAS = new Card(this.SEIS, this.ESPADAS, 26);
	 private final Card SIETE_ESPADAS = new Card(this.SIETE, this.ESPADAS, 27);
	 private final Card SOTA_ESPADAS = new Card(this.SOTA, this.ESPADAS, 28);
	 private final Card CABALLO_ESPADAS = new Card(this.CABALLO, this.ESPADAS, 29);
	 private final Card REY_ESPADAS = new Card(this.REY, this.ESPADAS, 30);
	 private final Card AS_BASTOS = new Card(this.AS, this.BASTOS, 31);
	 private final Card DOS_BASTOS = new Card(this.DOS, this.BASTOS, 32);
	 private final Card TRES_BASTOS = new Card(this.TRES, this.BASTOS, 33);
	 private final Card CUATRO_BASTOS = new Card(this.CUATRO, this.BASTOS, 34);
	 private final Card CINCO_BASTOS = new Card(this.CINCO, this.BASTOS, 35);
	 private final Card SEIS_BASTOS = new Card(this.SEIS, this.BASTOS, 36);
	 private final Card SIETE_BASTOS = new Card(this.SIETE, this.BASTOS, 37);
	 private final Card SOTA_BASTOS = new Card(this.SOTA, this.BASTOS, 38);
	 private final Card CABALLO_BASTOS = new Card(this.CABALLO, this.BASTOS, 39);
	 private final Card REY_BASTOS = new Card(this.REY, this.BASTOS, 40);
 
	 private final Card[] allCards = { this.AS_OROS, this.DOS_OROS, this.TRES_OROS, this.CUATRO_OROS, this.CINCO_OROS, this.SEIS_OROS, this.SIETE_OROS, this.SOTA_OROS, this.CABALLO_OROS, this.REY_OROS, this.AS_COPAS, this.DOS_COPAS, this.TRES_COPAS, this.CUATRO_COPAS, this.CINCO_COPAS, this.SEIS_COPAS, this.SIETE_COPAS, this.SOTA_COPAS, this.CABALLO_COPAS, this.REY_COPAS, this.AS_ESPADAS, this.DOS_ESPADAS, this.TRES_ESPADAS, this.CUATRO_ESPADAS, this.CINCO_ESPADAS, this.SEIS_ESPADAS, this.SIETE_ESPADAS, this.SOTA_ESPADAS, this.CABALLO_ESPADAS, this.REY_ESPADAS, this.AS_BASTOS, this.DOS_BASTOS, this.TRES_BASTOS, this.CUATRO_BASTOS, this.CINCO_BASTOS, this.SEIS_BASTOS, this.SIETE_BASTOS, this.SOTA_BASTOS, this.CABALLO_BASTOS, this.REY_BASTOS };
 
	 private int numReverses = 1;
	 private TextureRegion[] allReverses;
   
	 private Sound soundFlip;
	 private Sprite spriteSelect;
	 private Context parentContext;

	 protected BitmapTextureAtlas mBitmapTextureAtlasCards;	 	 	

 
	 /* Constructors */
	 
	 public EscobaPackage(Sound sound, Sprite sprite, Context context) {
		 this(".png", sound, sprite, context);
	 }
 
	 public EscobaPackage(String ext, Sound sound, Sprite sprite, Context context) {
		 this.EXT = ext;
		 this.soundFlip = sound;
		 this.spriteSelect = sprite;
		 this.parentContext = context;
		 this.mBitmapTextureAtlasCards = new BitmapTextureAtlas(1024 ,512, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		 BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/cards40/");
		 loadCardImages();
		 loadReverses();
		 setImageReverse(this.allReverses[0]);        
	 }
	 
	 /* Mtodes */
	 
	 /**
	  * Carrega les imatges corresponents als reversos definits (si n'hi ha ms d'un)
	  */
	 private void loadReverses() {
		 this.allReverses = new TextureRegion[this.numReverses];
		 for (int i = 1; i <= this.numReverses; i++){
			 int posX = (i + 7) * SpriteCard.CARD_WIDTH;
			 int posY = 3 * SpriteCard.CARD_HEIGHT;
			 String imageName = "reverso" + i + this.EXT;
			 this.allReverses[(i - 1)] = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBitmapTextureAtlasCards, parentContext, imageName, posX, posY); 
		 }
	 }
	 
	 /**
	  * Carrega les imatges corresponents a les cares de les cartes
	  */
	 public void loadCardImages() {
		 for (int i = 0; i < this.allCards.length; i++) {	   
			 int posX = (i % 11) * SpriteCard.CARD_WIDTH;
			 int posY = ((i - (i % 11)) / 11) * SpriteCard.CARD_HEIGHT;
		 
			 String imageName = "c" + Integer.toString(this.allCards[i].getNumber()) + this.EXT;
			 this.allCards[i].setImage(BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBitmapTextureAtlasCards, parentContext, imageName, posX, posY));
			 this.allCards[i].sprite = new SpriteCard(0, 0, this.allCards[i].getImage(), soundFlip, spriteSelect);
		 }
	 }
	 
	 /* Getters i Setters */
	 
	 public BitmapTextureAtlas getmBitmapTextureAtlasCards() {
		 return this.mBitmapTextureAtlasCards;
	 }
 
	 public Card[] getAllCards() {
		 return this.allCards;
	 }
 
	 public Card getCard(int num) {
		 if ((num < 0) || (num >= this.allCards.length)) return null;
		 return this.allCards[num];
	 }
 
	 public Rank[] getAllRanks() {
		 return this.allRanks;
	 }
 
	 public TextureRegion[] getAllReverses() {
		 return this.allReverses;
	 }
 
	 public Suit[] getAllSuits() {
		 return this.allSuits;
	 }
 
	 public String getImageExt() {
		 return this.EXT;
	 }
 
	 public TextureRegion getImageIcon(int icon) {
		 return null;
	 }
 
	 public String getPackageName() {
		 return this.NAME;
	 } 
 
	 public void setImageReverse(TextureRegion reverse) {
		 for (int i = 0; i < this.allCards.length; i++)
			 this.allCards[i].setImageReverse(reverse);
	 }
   
	 public TextureRegion getImageReverse(int index) {
		 return this.allReverses[index];
	 }
 }