package com.sweep15;

import java.io.IOException;
import java.util.ArrayList;

import org.anddev.andengine.audio.sound.Sound;
import org.anddev.andengine.audio.sound.SoundFactory;
import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.LimitedFPSEngine;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.handler.IUpdateHandler;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.scene.menu.MenuScene;
import org.anddev.andengine.entity.scene.menu.item.IMenuItem;
import org.anddev.andengine.entity.sprite.AnimatedSprite;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.entity.sprite.TiledSprite;
import org.anddev.andengine.entity.text.Text;
import org.anddev.andengine.entity.util.FPSLogger;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.opengl.font.FontFactory;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.ui.activity.LayoutGameActivity;
import org.anddev.andengine.util.Debug;
import org.anddev.andengine.util.HorizontalAlign;

import android.graphics.Typeface;
import android.os.Handler;
import android.view.KeyEvent;

import com.sweep15.GameElements.EscobaPackage;

public class Sweep15GameLocalActivity extends LayoutGameActivity
	implements MenuScene.IOnMenuItemClickListener, Scene.IOnSceneTouchListener
{
	/* Constants */
	
	public static final int CAMERA_HEIGHT = 480;
	public static final int CAMERA_WIDTH = 720;
	protected static final int CPUHAND_POSY = -40;

	protected static final int MENU_BACK = 2;
	protected static final int MENU_QUIT = 1;
	protected static final int MENU_RESET = 0;
  
	/* Propietats */
	
	private static EscobaPackage pack; //Definici de cartes segons el joc de l'escombra
  
	private GameLocalController gameLocalController;
	
	protected Sprite deck; //Sprite per la baralla
	protected Sprite dealer; //Sprite per l'indicador de qui reparteix
	protected Sprite spriteDeckCpu; //Sprite que substitueix la pila de cartes capturades
	protected Sprite spriteDeckPlayer; //Sprite que substitueix la pila de cartes capturades
	protected Sprite score; //Sprite per puntuacions
	protected Sprite selectedCard; //Sprite per selecci de carta
	
	protected Sound mCardFlipSound; //So de girar la carta
	protected Sound mShuffleSound; //So de barrejar la baralla
	protected Sound mBeep;
	protected Sound mGo;
	protected Sound mAmbience;
	protected Sound mBoo;
	protected Sound mStream;
	protected Sound mCheer;
	
	protected AnimatedSprite ShuffleDeck; //Animaci de barrejar les cartes
	
	protected MsgGame msgGame; //Missatges durant el joc
	
	protected float dealerPosX; //Posici X de l'indicador de repartidor
	protected float deckPosY; //Posici Y de la baralla
	
	protected Text tMsgGameOver;
	protected Text tPointsCpu;
	protected Text tPointsPlayer;
	protected ArrayList<Text> tScore;
	protected Text tTouchContinue;
	protected Sprite trophy;
	protected final Handler updateHandler = new Handler();
	
	protected Font mFont;
	private BitmapTextureAtlas mFontTextureAtlas;
	protected Font mFrankFont;
	private BitmapTextureAtlas mFrankFontTextureAtlas;
	 
	protected TiledSprite PlayButton;
	protected TiledSprite ThrowButton;
	
	protected Sprite deckPanel;
	protected Sprite infoButton;
	
	private BitmapTextureAtlas mBgTextureAtlas;
	private TextureRegion mBgTextureRegion;
	private BitmapTextureAtlas mButtonsTextureAtlas;
	protected Camera mCamera;
	
	protected TiledTextureRegion mContinuePlayingButtonTextureRegion;
	protected TextureRegion mDealerTextureRegion;
	protected TextureRegion mDeckPanelTextureRegion;
	protected TextureRegion mDeckTextureRegion;
	private BitmapTextureAtlas mDecorationTextureAtlas;
	
	public IUpdateHandler mIUpdateHandler;
	protected TextureRegion mInfoButtonTextureRegion;
	protected Scene mMainScene;
	protected TextureRegion mMenuBackTextureRegion;
	protected TextureRegion mMenuQuitTextureRegion;
	protected TextureRegion mMenuResetTextureRegion;
	protected MenuScene mMenuScene;
	protected TiledTextureRegion mPlayButtonTextureRegion;
	protected TextureRegion mScorePanelRegion;
	private BitmapTextureAtlas mSelectedCardTextureAtlas;
	protected TextureRegion mSelectedCardTextureRegion;
	
	private BitmapTextureAtlas mShuffleTextureAtlas;
	protected TiledTextureRegion mShuffleTextureRegion;
	protected TiledTextureRegion mThrowButtonTextureRegion;
	private float mTouchX = 0.0F;
	private float mTouchY = 0.0F;
	protected TextureRegion mTrophyTextureRegion;
	public IUpdateHandler mainIUpdateHandler;
	 
  
	public EscobaPackage getPackage() {
		return pack;
	}

	private void initResources() {
		this.tScore = new ArrayList<Text>();      
		this.dealerPosX = (this.mDealerTextureRegion.getWidth() / 3);
      
		this.msgGame = new MsgGame(MainActivity.CAMERA_WIDTH / 2, MainActivity.CAMERA_HEIGHT / 2, this.mFrankFont, "", HorizontalAlign.CENTER, 25);
      
		this.gameLocalController = new GameLocalController(this);
      
		float posY = MainActivity.CAMERA_HEIGHT - this.mPlayButtonTextureRegion.getHeight();
		this.PlayButton = new TiledSprite(530F, posY, this.mPlayButtonTextureRegion) {
			public boolean onAreaTouched(TouchEvent pTouchEvent, float pTouchX, float pTouchY) {
				if (pTouchEvent.getAction() == TouchEvent.ACTION_DOWN) {
					Sweep15GameLocalActivity.this.gameLocalController.onTouchPlayButton();
					setCurrentTileIndex(1);
				} else if (pTouchEvent.getAction() == TouchEvent.ACTION_UP) {
					setCurrentTileIndex(0);
				}
				return true;
			}
		};
      
		posY = MainActivity.CAMERA_HEIGHT - this.mThrowButtonTextureRegion.getHeight();
		this.ThrowButton =  new TiledSprite(102F, posY, this.mThrowButtonTextureRegion) {
			public boolean onAreaTouched(TouchEvent pTouchEvent, float pTouchX, float pTouchY) {
				if (pTouchEvent.getAction() == TouchEvent.ACTION_DOWN) {
					Sweep15GameLocalActivity.this.gameLocalController.onTouchThrowButton();
					setCurrentTileIndex(1);
				} else if (pTouchEvent.getAction() == TouchEvent.ACTION_UP) {
					setCurrentTileIndex(0);
				}
				return true;
			}
		};
      
		this.score = new Sprite(90F, 65F, this.mScorePanelRegion) {
			public boolean onAreaTouched(TouchEvent pTouchEvent, float pTouchX, float pTouchY) {
				if (pTouchEvent.getAction() == TouchEvent.ACTION_DOWN) {
					Sweep15GameLocalActivity.this.gameLocalController.onTouchScore();
				}
				return true;
			}
		};
      
		this.infoButton = new Sprite(5F, 10F, this.mInfoButtonTextureRegion) {
			public boolean onAreaTouched(TouchEvent pTouchEvent, float pTouchX, float pTouchY) { 
				if (pTouchEvent.getAction() == TouchEvent.ACTION_DOWN) {
					Sweep15GameLocalActivity.this.gameLocalController.onTouchDownInfoButton();
				} else if (pTouchEvent.getAction() == TouchEvent.ACTION_UP) {
					Sweep15GameLocalActivity.this.gameLocalController.onTouchUpInfoButton();
				}
				return true;
			}
		};
      
		float lDeckPanel = (MainActivity.CAMERA_HEIGHT - this.mDeckPanelTextureRegion.getHeight()) / 2;      
		this.deckPanel = new Sprite(0F, lDeckPanel, this.mDeckPanelTextureRegion);
		this.deckPosY = (MainActivity.CAMERA_HEIGHT - this.mDeckTextureRegion.getHeight()) / 2;
		this.deck = new Sprite(0F, this.deckPosY, this.mDeckTextureRegion);
		this.spriteDeckPlayer = new Sprite(-20F, this.deckPosY, pack.getImageReverse(0).deepCopy());
		this.spriteDeckCpu = new Sprite(0F, this.deckPosY, pack.getImageReverse(0).deepCopy());
		this.trophy = new Sprite(0F, 0F, this.mTrophyTextureRegion);
		posY = (MainActivity.CAMERA_HEIGHT / 2) - this.mDeckTextureRegion.getHeight();
		this.dealer = new Sprite(this.dealerPosX, posY, this.mDealerTextureRegion);
      
		this.tTouchContinue = new Text(214F, 415F, this.mFont, this.getResources().getText(R.string.msgTOUCH_TO_CONTINUE).toString(), HorizontalAlign.LEFT);
		this.tTouchContinue.setColor(0F, 0F, 0F);
	}

	protected void createMenuScene() {
	  //TODO Pendent de fer un men per confirmar si es vol abandonar la partida
	}

	protected int getLayoutID() {
		return R.layout.main;
	}

	protected int getRenderSurfaceViewID() {
		return R.id.xmllayoutexample_rendersurfaceview;
	}

	public boolean onKeyDown(final int pKeyCode, final KeyEvent pEvent) {
		if(pKeyCode == KeyEvent.KEYCODE_MENU && pEvent.getAction() == KeyEvent.ACTION_DOWN) {
			if(this.mMainScene.hasChildScene()) {
				/* Remove the menu and reset it. */
				this.mMenuScene.back();
			} else {
				/* Attach the menu. */
				//TODO treure desprs de debugar!
				this.finish();
				//this.mEngine.setScene(this.mMenuScene);				
			}
			return true;
		} else {
			return super.onKeyDown(pKeyCode, pEvent);
		}
	}

	public void onLoadComplete() {
	}

	public Engine onLoadEngine() {
		this.mCamera = new Camera(0.0F, 0.0F, MainActivity.CAMERA_WIDTH, MainActivity.CAMERA_HEIGHT);
		EngineOptions lEngineOptions = new EngineOptions(true, EngineOptions.ScreenOrientation.LANDSCAPE, new RatioResolutionPolicy(MainActivity.CAMERA_WIDTH, MainActivity.CAMERA_HEIGHT), this.mCamera);
		lEngineOptions.getTouchOptions().setRunOnUpdateThread(true);
		lEngineOptions.setNeedsSound(true);
		return new LimitedFPSEngine(lEngineOptions, 60);
	}

	public void onLoadResources() {
		this.mFontTextureAtlas = new BitmapTextureAtlas(256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		FontFactory.setAssetBasePath("font/");
		this.mFont = new Font(this.mFontTextureAtlas, Typeface.create(Typeface.DEFAULT, 1), 24F, true, -1);
		this.mEngine.getTextureManager().loadTexture(this.mFontTextureAtlas);
		this.mEngine.getFontManager().loadFont(this.mFont);
		this.mFrankFontTextureAtlas = new BitmapTextureAtlas(256, 256, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
		this.mFrankFont = FontFactory.createFromAsset(this.mFrankFontTextureAtlas, this, "IronMan.ttf", 32.0F, true, -1);
		this.mEngine.getTextureManager().loadTexture(this.mFrankFontTextureAtlas);
		this.mEngine.getFontManager().loadFont(this.mFrankFont);
		SoundFactory.setAssetBasePath("sfx/");
		try {			
			this.mShuffleSound = SoundFactory.createSoundFromAsset(this.mEngine.getSoundManager(), this, "shuffling-cards.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mCardFlipSound = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "flip.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mBeep = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "beep.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mGo = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "go.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mCheer = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "cheer.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mStream = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "stream.mp3");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mBoo = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "boo.wav");
		} catch (IOException ioexception) {
			Debug.e(ioexception);
		}
		try {
			mAmbience = SoundFactory.createSoundFromAsset(mEngine.getSoundManager(), this, "ambience.mp3");
		} catch(IOException ioexception1) {
			Debug.e(ioexception1);
		}
			this.mDecorationTextureAtlas = new BitmapTextureAtlas(1024, 1024, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
			BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
			this.mScorePanelRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDecorationTextureAtlas, this, "Score.png", 0, 0);
			this.mDeckPanelTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDecorationTextureAtlas, this, "deckMark.png", 601, 0);
			this.mDeckTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDecorationTextureAtlas, this, "Deck.png", 687, 0);
			this.mDealerTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDecorationTextureAtlas, this, "dealer.png", 767, 0);
			this.mTrophyTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mDecorationTextureAtlas, this, "trophy.png", 160, 401);
			this.mEngine.getTextureManager().loadTexture(this.mDecorationTextureAtlas); 	 
	  
			this.mBgTextureAtlas = new BitmapTextureAtlas(1024 ,512, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
			BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
			this.mBgTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mBgTextureAtlas, this, "Felt-GameField.jpg", 0, 0);
			this.mEngine.getTextureManager().loadTexture(this.mBgTextureAtlas);
          
			this.mSelectedCardTextureAtlas = new BitmapTextureAtlas(128, 256, TextureOptions.NEAREST);
			BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
			this.mSelectedCardTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mSelectedCardTextureAtlas, this, "selected.png", 0, 0);
			this.mEngine.getTextureManager().loadTexture(this.mSelectedCardTextureAtlas);
      
			this.mButtonsTextureAtlas = new BitmapTextureAtlas(1024, 128, TextureOptions.BILINEAR);
			BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");          
			this.mPlayButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.mButtonsTextureAtlas, this, "PlayButton.png", 0, 0, 2, 1);
			this.mThrowButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.mButtonsTextureAtlas, this, "ThrowButton.png", 300, 0, 2, 1);
			this.mInfoButtonTextureRegion = BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.mButtonsTextureAtlas, this, "information_button.png", 600, 0);
			this.mEngine.getTextureManager().loadTexture(this.mButtonsTextureAtlas);
			this.mShuffleTextureAtlas = new BitmapTextureAtlas(1024, 512, TextureOptions.NEAREST);
			BitmapTextureAtlasTextureRegionFactory.setAssetBasePath("gfx/");
			this.mShuffleTextureRegion = BitmapTextureAtlasTextureRegionFactory.createTiledFromAsset(this.mShuffleTextureAtlas, this, "Shuffle_Red.png", 0, 0, 11, 3);
			this.mEngine.getTextureManager().loadTexture(this.mShuffleTextureAtlas);
      
			/* Carreguem les textures/sprites de les cartes */
			this.selectedCard = new Sprite(200F, 100F, this.mSelectedCardTextureRegion);
			pack = new EscobaPackage(this.mCardFlipSound, this.selectedCard, this);
			this.mEngine.getTextureManager().loadTexture(pack.getmBitmapTextureAtlasCards());
	  
			/* Inicialitzem els recursos */
			initResources();
	}

	public Scene onLoadScene() {
		this.mEngine.registerUpdateHandler(new FPSLogger());
		//    createMenuScene();
		this.mMainScene = new Scene();
		/* Tapete de joc */
		Sprite lSpriteBackground = new Sprite(0.0F, 0.0F, this.mBgTextureRegion);
		this.mMainScene.attachChild(lSpriteBackground);
		this.ShuffleDeck = new AnimatedSprite(0.0F, 0.0F, this.mShuffleTextureRegion);
		this.ShuffleDeck.setScale(1.5F, 1.2F);
		this.ShuffleDeck.setPosition(25.0F, this.deckPosY - 5F);
		this.mMainScene.getLastChild().attachChild(this.deckPanel);
		this.mMainScene.getLastChild().attachChild(this.dealer);
		this.mMainScene.getLastChild().attachChild(this.PlayButton);
		this.mMainScene.registerTouchArea(this.PlayButton);
		this.mMainScene.getLastChild().attachChild(this.ThrowButton);
		this.mMainScene.registerTouchArea(this.ThrowButton);
		this.mMainScene.getLastChild().attachChild(this.infoButton);
		this.mMainScene.registerTouchArea(this.infoButton);
		this.mMainScene.getLastChild().attachChild(this.msgGame);
    
		this.mMainScene.setTouchAreaBindingEnabled(true);
		this.mMainScene.setOnSceneTouchListener(this);
		this.mMainScene.registerUpdateHandler(new IUpdateHandler() {
			/* Control principal del joc!! */
			public void onUpdate(float paramFloat) {		
				Sweep15GameLocalActivity.this.gameLocalController.gameStateProcess();
			}
			public void reset()	{
			}
		});

		return this.mMainScene;
	}

	public boolean onMenuItemClicked(MenuScene paramMenuScene, IMenuItem paramIMenuItem, float paramFloat1, float paramFloat2) {
		return true;
	}

	public boolean onSceneTouchEvent(Scene scene, TouchEvent touchEvent) {
		if (touchEvent.isActionDown())  {
			/* Guardem el punt de contacte */
			this.mTouchX = touchEvent.getX();
			this.mTouchY = touchEvent.getY();	      
		} else if (touchEvent.isActionUp()) {
			/* Actuem sobre la carta corresponent */
			this.gameLocalController.checkTouchPointOnCards(this.mTouchX, this.mTouchY);		
		}
		return true;
	}
}