package com.sweep15;

import org.anddev.andengine.entity.text.ChangeableText;
import org.anddev.andengine.opengl.font.Font;
import org.anddev.andengine.util.HorizontalAlign;

/**
 * Classe que implementa un text cambiable d'AndEngine, que s'utilitzar per mostrar els missatges del joc
 * 
 * @author Sergi Collado Figueras : PFC - Xarxes de computadors 2011-2012
 *
 */
public class MsgGame extends ChangeableText
{
  public Boolean detach = Boolean.valueOf(false);
  float duration = 0.0F;
  float elapsed = 0.0F;
  boolean isActive = false;
  float percentScale;

  public MsgGame(float paramFloat1, float paramFloat2, Font paramFont, String paramString, HorizontalAlign paramHorizontalAlign, int paramInt)
  {
    super(paramFloat1, paramFloat2, paramFont, paramString, paramHorizontalAlign, paramInt);
    setColor(1.0F, 1.0F, 1.0F);
  }

  private void AccumulateElapsedTime(float paramFloat)
  {
    this.elapsed = (paramFloat + this.elapsed);
  }

  public void InitMsgGame(String paramString, int paramInt1, int paramInt2, Font paramFont, float paramFloat)
  {
    setVisible(true);
    setText(paramString);
    setPosition(paramInt1, paramInt2);
    this.duration = paramFloat;
    this.elapsed = 0.0F;
    this.isActive = true;
  }

  protected void onManagedUpdate(float paramFloat)
  {
    if (this.isActive)
    {
      AccumulateElapsedTime(paramFloat);
      if (this.elapsed <= this.duration) {
    	  this.percentScale = (0.05F + getScaleX());
          setScale(this.percentScale);
          return;
      }
      this.elapsed = 0.0F;
      this.isActive = false;
      this.duration = 0.0F;
      setScale(1.0F);
      setVisible(false);
    }
  }
}